ImplicitReplyActivity subclass: #SelectiveAcceptActivity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Ext-SelectActivity'!


!SelectiveAcceptActivity methodsFor: 'message handling'!

isAcceptableMessage: aMessage
	"Checking if a message may be accepted."
	"Default check is always true."

	^true!

nextMessage
	"Next message is first acceptable message."

	| message |
	message := super nextMessage.
	[self isAcceptableMessage: message] whileFalse:
		[address resend: message.
		message := super nextMessage].
	^message! !

ImplicitReplyActivity subclass: #EnabledSelectorsActivity
	instanceVariableNames: 'enabledSelectors '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Ext-SelectActivity'!
EnabledSelectorsActivity comment:
'Class AcceptReplaceActorBehavior is a subclass of class ReplaceActorBehavior and provides control over acceptance of messages.
Basically it looks only for messages that it knows (selectors of defined methods). This is useful to disable method acceptance (without relying on trapping errors and resending messages as in class NullBoundedBuffer).
Method nextMessage is redefined to look for messages that the class knows (defines or inherits).
See class AcceptNullBoundedBuffer in category Actalk-Ext-Replace-Ext-Ex as the resulting improved version of the bounded buffer example.'!


!EnabledSelectorsActivity methodsFor: 'message handling'!

nextMessage
	"Look into the mailbox for the first message matching one of the enabled selectors."

	"Note that this is an abstract class.
	The subclass needs to define the actual initialization/assignment of the enabled selectors."

	^self mailBox firstMessageAmong: enabledSelectors! !
